// *****************************************************************************
// VGDD Main Skeleton - Header file
// This program is the starting point to build a VGDD-enabled GOL Application
// *****************************************************************************
// FileName:            VGDDMain.h
// Dependencies:        See INCLUDES section below
// Compiler:            XC32
// Development Board:   EXPLORER16
// Expansion Board:     GFX_SSD1926
// Company:             VirtualFab, parts from Microchip Technology Incorporated
//
// VirtualFab Software License Agreement:
// Copyright 2012 Virtualfab - All rights reserved.
// Redistribution and use in source and binary forms, with or without modification, are permitted
// provided that the following conditions are met:
// Redistributions of source code must retain the above and following copyright notices,
// this list of conditions and the following disclaimer.
// Neither the name of the Fabio Violino or Virtualfab may be used to endorse or promote products
// derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR “AS IS” AND ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
// OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Microchip's Software License Agreement:
//
// Copyright © 2012 Microchip Technology Inc.  All rights reserved.
// Microchip licenses to you the right to use, modify, copy and distribute
// Software only when embedded on a Microchip microcontroller or digital
// signal controller, which is integrated into your product or third party
// product (pursuant to the sublicense terms in the accompanying license
// agreement).
//
// You should refer to the license agreement accompanying this Software
// for additional information regarding your rights and obligations.
//
// SOFTWARE AND DOCUMENTATION ARE PROVIDED “AS IS” WITHOUT WARRANTY OF ANY
// KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
// OF MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR
// PURPOSE. IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR
// OBLIGATED UNDER CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION,
// BREACH OF WARRANTY, OR OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT
// DAMAGES OR EXPENSES INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL,
// INDIRECT, PUNITIVE OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA,
// COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY
// CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF),
// OR OTHER SIMILAR COSTS.
//
// Author               Date        Comment
//
// VirtualFab        2012/01/29     First MPLABX Wizard implementation 
// *****************************************************************************
#ifndef _VGDDMAIN_H
#define _VGDDMAIN_H

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "Compiler.h"

#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#if defined(USE_SST25VF016)
	#include "SST25VF016.h"
#endif
#include "TimeDelay.h"
#include "Graphics/Graphics.h"
#include "rtcc.h"
#include "TouchScreen.h"

#if defined(USE_BITMAP_SD)
#include "usb_config.h"
#include "USB/usb.h"
#include "USB/usb_host_msd.h"
#include "USB/usb_host_hid_parser.h"
#include "USB/usb_host_hid.h"
#include "drv_spi.h"
#endif

// VGDD_MPLABX_WIZARD_START_SECTION: MainHeader *** DO NOT DELETE THIS LINE! ***
#include "cpld.h"
#include "SST25VF016.h"
#include "TouchScreen.h"
#include "SST25VF016.h"


// VGDD_MPLABX_WIZARD_END_SECTION *** DO NOT DELETE THIS LINE! ***

/////////////////////////////////////////////////////////////////////////////
//                            APPLICATION STATES
/////////////////////////////////////////////////////////////////////////////

typedef enum {
// Put here your manually defined screens states

#include "VGDD_Soln_P32_Lab1_ScreenStates.h"

} SCREEN_STATES;

#include "VGDD_Soln_P32_Lab1_Screens.h"

volatile extern SCREEN_STATES screenState;

#endif // _VGDDMAIN_H
