// *****************************************************************************
// VGDD Main Skeleton
// This program is the starting point to build a VGDD-enabled GOL Application
// *****************************************************************************
// FileName:          VGDDMain.c
// Generated by:      VGDD 3.7.0 MplabX Wizard Copyright © VirtualFab 2011-2012
// Dependencies:      VGDDMain.h, VGDD_Soln_Lab2_PIC32_Screens.c, VGDD_Soln_Lab2_PIC32_Screens.h
// Compiler:          XC32
// Development Board: EXPLORER16
// Expansion Board:   GFX_SSD1926
// Display Board:     POWERTIP_4_3 - Orientation: 0 degrees
// Company:           VirtualFab, with adapted parts from Microchip Technology Incorporated
//
// *****************************************************************************
// VirtualFab Software License Agreement:
// *****************************************************************************
// Copyright © VirtualFab 2011-2012 - All rights reserved.
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// Redistributions of source code must retain the above and following copyright notices,
// this list of conditions and the following disclaimer.
// Neither the name of Fabio Violino or VirtualFab may be used to endorse or promote 
// products derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR “AS IS” AND ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// *****************************************************************************
// Microchip's Software License Agreement:
// *****************************************************************************
// Copyright © 2012 Microchip Technology Inc.  All rights reserved.
// Microchip licenses to you the right to use, modify, copy and distribute
// Software only when embedded on a Microchip microcontroller or digital
// signal controller, which is integrated into your product or third party
// product (pursuant to the sublicense terms in the accompanying license
// agreement).
//
// You should refer to the license agreement accompanying this Software
// for additional information regarding your rights and obligations.
//
// SOFTWARE AND DOCUMENTATION ARE PROVIDED “AS IS” WITHOUT WARRANTY OF ANY
// KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
// OF MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR
// PURPOSE. IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR
// OBLIGATED UNDER CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION,
// BREACH OF WARRANTY, OR OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT
// DAMAGES OR EXPENSES INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL,
// INDIRECT, PUNITIVE OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA,
// COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY
// CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF),
// OR OTHER SIMILAR COSTS.
//
// Author               Date        Comment
//
// VirtualFab        2012/01/29     First MPLABX Wizard implementation 
// VirtualFab        2012/03/05     VGDD 3.2 Release
// *****************************************************************************
#include "VGDDmain.h"

// Configuration bits
// VGDD_MPLABX_WIZARD_START_SECTION: ConfigBits *** DO NOT DELETE THIS LINE! ***
// Configuration bits
#if defined(__dsPIC33F__) || defined(__PIC24H__)
_FOSCSEL(FNOSC_PRI);
_FOSC(FCKSM_CSECMD &OSCIOFNC_OFF &POSCMD_XT);
_FWDT(FWDTEN_OFF);
#elif defined(__dsPIC33E__) || defined(__PIC24E__)
_FOSCSEL(FNOSC_FRC);            
_FOSC(FCKSM_CSECMD & POSCMD_XT & OSCIOFNC_OFF & IOL1WAY_OFF);
_FWDT(FWDTEN_OFF);
_FPOR(FPWRT_PWR128 & BOREN_ON & ALTI2C1_ON & ALTI2C2_ON);
_FICD(ICS_PGD1 & RSTPRI_PF & JTAGEN_OFF);
#elif defined(__PIC32MX__)
    #pragma config FPLLODIV = DIV_1, FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FWDTEN = OFF, FCKSM = CSECME, FPBDIV = DIV_1
    #pragma config OSCIOFNC = ON, POSCMOD = XT, FSOSCEN = ON, FNOSC = PRIPLL
    #pragma config CP = OFF, BWP = OFF, PWP = OFF
#else
    #if defined(__PIC24FJ256GB110__)
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & FWDTEN_OFF & ICS_PGx2)
_CONFIG2(0xF7FF & IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_OFF & POSCMOD_HS & FNOSC_PRIPLL & PLLDIV_DIV2 & IOL1WAY_OFF)
    #endif
    #if defined(__PIC24FJ256GA110__)
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & FWDTEN_OFF & ICS_PGx2)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_OFF & POSCMOD_HS & FNOSC_PRIPLL & IOL1WAY_OFF)
    #endif
    #if defined(__PIC24FJ128GA010__)
_CONFIG2(FNOSC_PRIPLL & POSCMOD_XT) // Primary XT OSC with PLL
_CONFIG1(JTAGEN_OFF & FWDTEN_OFF)   // JTAG off, watchdog timer off
    #endif
    #if defined (__PIC24FJ256GB210__)
_CONFIG1( WDTPS_PS32768 & FWPSA_PR128 & ALTVREF_ALTVREDIS & WINDIS_OFF & FWDTEN_OFF & ICS_PGx2 & GWRP_OFF & GCP_OFF & JTAGEN_OFF) 
_CONFIG2( POSCMOD_HS & IOL1WAY_OFF & OSCIOFNC_OFF & OSCIOFNC_OFF & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
_CONFIG3( WPFP_WPFP255 & SOSCSEL_SOSC & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM) 
    #endif
    #if defined (__PIC24FJ256DA210__)
_CONFIG1( WDTPS_PS32768 & FWPSA_PR128 & ALTVREF_ALTVREDIS & WINDIS_OFF & FWDTEN_OFF & ICS_PGx2 & GWRP_OFF & GCP_OFF & JTAGEN_OFF) 
_CONFIG2( POSCMOD_HS & IOL1WAY_OFF & OSCIOFNC_OFF & OSCIOFNC_OFF & FCKSM_CSDCMD & FNOSC_PRIPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
_CONFIG3( WPFP_WPFP255 & SOSCSEL_EC & WUTSEL_LEG & ALTPMP_ALTPMPEN & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM) 
    #endif    
#endif

// VGDD_MPLABX_WIZARD_END_SECTION *** DO NOT DELETE THIS LINE! ***

/////////////////////////////////////////////////////////////////////////////
//                            LOCAL PROTOTYPES
/////////////////////////////////////////////////////////////////////////////
#define WAIT_UNTIL_FINISH(x)    while(!x)
void InitializeBoard(void);
void TickInit(void);

/////////////////////////////////////////////////////////////////////////////
// SPI Channel settings
/////////////////////////////////////////////////////////////////////////////
#if defined (SPI_CHANNEL_1_ENABLE) || defined (SPI_CHANNEL_2_ENABLE) || defined (SPI_CHANNEL_3_ENABLE) || defined (SPI_CHANNEL_4_ENABLE)
    #if defined (USE_SST25VF016)
        #ifdef __PIC32MX
            const DRV_SPI_INIT_DATA SPI_Init_Data = {SST25_SPI_CHANNEL, 1, 0, 0, 1, 1, 0};
        #else
            const DRV_SPI_INIT_DATA SPI_Init_Data = {SST25_SPI_CHANNEL, 3, 6, 0, 1, 1, 0};
        #endif
    #elif defined (USE_MCHP25LC256)
        const DRV_SPI_INIT_DATA SPI_Init_Data = {MCHP25LC256_SPI_CHANNEL, 6, 3, 0, 1, 1, 0};
    #endif
#endif

/////////////////////////////////////////////////////////////////////////////
// SPI Device Initialization Function
/////////////////////////////////////////////////////////////////////////////
#if defined (USE_SST25VF016)
    // initialize GFX3 SST25 flash SPI
    #define FlashInit(pInitData) SST25Init((DRV_SPI_INIT_DATA*)pInitData);
#elif defined (USE_MCHP25LC256)
    // initialize EEPROM on Explorer 16
    #define FlashInit(pInitData) MCHP25LC256Init((DRV_SPI_INIT_DATA*)pInitData);
#endif

/////////////////////////////////////////////////////////////////////////////
//                             FONTS USED
/////////////////////////////////////////////////////////////////////////////
extern const FONT_FLASH GOLFontDefault; // default GOL font

// MainHead
// VGDD_MPLABX_WIZARD_START_SECTION: MainHead *** DO NOT DELETE THIS LINE! ***
// VGDD_MPLABX_WIZARD_END_SECTION *** DO NOT DELETE THIS LINE! ***

/////////////////////////////////////////////////////////////////////////////
//                       GLOBAL VARIABLES FOR APPLICATION
/////////////////////////////////////////////////////////////////////////////
volatile SCREEN_STATES screenState=SCREENSTATE_INIT; // current state of state machine
DWORD tick;
#if defined(USE_BITMAP_SD)
BYTE                    usbErrorCode;                       // USB error
#endif

/////////////////////////////////////////////////////////////////////////////
//                                  MAIN
/////////////////////////////////////////////////////////////////////////////

int main(void) {
    GOL_MSG msg; // GOL message structure to interact with GOL
    InitializeBoard(); // Initialize hardware
//	RTCCInit(); // Setup the RTCC
//    RTCCProcessEvents();

    // Main Loop
    while (1) {
  //      ClrWdt();
#if defined(USE_BITMAP_SD)
  //      USBTasks();
#endif
        if (GOLDraw()) { // Draw GOL objects
            // Drawing is done here, process messages
            TouchGetMsg(&msg); // Get message from touch screen
            GOLMsg(&msg); // Process message
        }
        // The GUI is done.
        // Application "background" code goes here, i.e. handling network packets, etc...
    }
}

// Main
// VGDD_MPLABX_WIZARD_START_SECTION: Main *** DO NOT DELETE THIS LINE! ***
// VGDD_MPLABX_WIZARD_END_SECTION *** DO NOT DELETE THIS LINE! ***

/////////////////////////////////////////////////////////////////////////////
// Function: WORD GOLMsgCallback(WORD objMsg, OBJ_HEADER* pObj, GOL_MSG* pMsg)
// Input: objMsg - translated message for the object,
//        pObj - pointer to the object,
//        pMsg - pointer to the non-translated, raw GOL message
// Output: if the function returns non-zero the message will be processed by default
// Overview: this function must be implemented by user. GOLMsg() function calls it each
//           time the valid message for the object received
/////////////////////////////////////////////////////////////////////////////

WORD GOLMsgCallback(WORD objMsg, OBJ_HEADER *pObj, GOL_MSG *pMsg) {
/*
Only if you have manually defined screens (not VGDD-generated),
put here below the switch structure to handle messages like this:
      
WORD id= GetObjID(pObj);
switch (screenState) {
    case DISPLAY_MAIN:
        switch (id) {
            case ID_BUTTON_MENU:
                if (objMsg == BTN_MSG_RELEASED) {
                    screenState = CREATE_MENU;
                    return (1);
                }
                                    .
                                    .
                                    .
        }
}
*/

    // The following single call handles messages from all VGDD-generated screens
    return (VGDD_Soln_Lab2_PIC32_MsgCallback(objMsg, pObj, pMsg));
}

/////////////////////////////////////////////////////////////////////////////
// Function: WORD GOLDrawCallback()
// Output: if the function returns non-zero the draw control will be passed to GOL
// Overview: this function must be implemented by user. GOLDraw() function calls it each
//           time when GOL objects drawing is completed. User drawing should be done here.
//           GOL will not change color, line type and clipping region settings while
//           this function returns zero.
/////////////////////////////////////////////////////////////////////////////

WORD GOLDrawCallback(void) {
/*
    Only if you have manually defined screens (not VGDD-generated),
    put here below the switch structure to handle screenstates like this:
    
        switch (screenState) {
            case CREATE_MAIN:
            CreateMain(); // create main window
            screenState = DISPLAY_MAIN; // switch to next state
            return (1);
        case DISPLAY_MAIN:
                .
                .
                .
    */

    // The following single call handles screenstate changes of all VGDD-generated screens
    return (VGDD_Soln_Lab2_PIC32_DrawCallback());
}

// *********************************************************************
// Function: InitializeBoard()
// Input: none
// Output: none
// Overview: Initializes the hardware components including the PIC device
//           used.
// *********************************************************************
void InitializeBoard(void)
{
// VGDD_MPLABX_WIZARD_START_SECTION: InitializeBoard *** DO NOT DELETE THIS LINE! ***
    /////////////////////////////////////////////////////////////////////////////
    // ADC Explorer 16 Development Board Errata (work around 2)
    // RB15 should be output
    /////////////////////////////////////////////////////////////////////////////
 //   LATBbits.LATB15 = 0;
 //   TRISBbits.TRISB15 = 0;

#if defined(__dsPIC33F__) || defined(__PIC24H__) || defined(__dsPIC33E__) || defined(__PIC24E__)
    // Configure Oscillator to operate the device at 40Mhz
    // Fosc= Fin*M/(N1*N2), Fcy=Fosc/2
#if defined(__dsPIC33E__) || defined(__PIC24E__)
    //Fosc = 8M * 60/(2*2) = 120MHz for 8M input clock
    PLLFBD = 58; // M=60
#else
    // Fosc= 8M*40(2*2)=80Mhz for 8M input clock
    PLLFBD = 38; // M=40
#endif
    CLKDIVbits.PLLPOST = 0; // N1=2
    CLKDIVbits.PLLPRE = 0; // N2=2
    OSCTUN = 0; // Tune FRC oscillator, if FRC is used

    // Disable Watch Dog Timer
    RCONbits.SWDTEN = 0;

    // Clock switching to incorporate PLL
    __builtin_write_OSCCONH(0x03); // Initiate Clock Switch to Primary

    // Oscillator with PLL (NOSC=0b011)
    __builtin_write_OSCCONL(0x01); // Start clock switching
    while (OSCCONbits.COSC != 0b011);

    // Wait for Clock switch to occur
    // Wait for PLL to lock
    while (OSCCONbits.LOCK != 1) {
    };

#if defined(__dsPIC33F__) || defined(__PIC24H__)
    // Set PMD0 pin functionality to digital
    AD1PCFGL = AD1PCFGL | 0x1000;

#if defined(__dsPIC33FJ128GP804__) || defined(__PIC24HJ128GP504__)
    AD1PCFGLbits.PCFG6 = 1;
    AD1PCFGLbits.PCFG7 = 1;
    AD1PCFGLbits.PCFG8 = 1;
#endif

#elif defined(__dsPIC33E__) || defined(__PIC24E__)
    ANSELE = 0x00;
    ANSELDbits.ANSD6 = 0;

    // Set all touch screen related pins to Analog mode.
    ANSELBbits.ANSB11 = 1;
#endif

#elif defined(__PIC32MX__)
    INTEnableSystemMultiVectoredInt();
    SYSTEMConfigPerformance(GetSystemClock());
#endif // #if defined(__dsPIC33F__) || defined(__PIC24H__)


    /************************************************************************
     * For Explorer 16 RD12 is connected to EEPROM chip select.
     * To prevent a conflict between this EEPROM and SST25 flash
     * the chip select of the EEPROM SPI should be pulled up.
     ************************************************************************/
    // Set IOs directions for EEPROM SPI
//    MCHP25LC256_CS_LAT = 1; // set initial CS value to 1 (not asserted)
//    MCHP25LC256_CS_TRIS = 0; // set CS pin to output

    // Initialize graphics library and create default style scheme for GOL
    GOLInit();

    //The following are PIC device specific settings for the SPI channel
    //used.

    //Set IOs directions for SST25 SPI
#if defined (GFX_PICTAIL_LCC)
    SST25_CS_LAT = 1;
    SST25_CS_TRIS = 0;
#ifndef __PIC32MX__
    SST25_SCK_TRIS = 0;
    SST25_SDO_TRIS = 0;
    SST25_SDI_TRIS = 1;
#if defined(__PIC24FJ256GB210__) || defined(__dsPIC33E__) || defined(__PIC24E__)
    SST25_SDI_ANS = 0;
#endif
#endif
#endif

    // set the peripheral pin select for the SPI channel used
#if defined(__dsPIC33FJ128GP804__) || defined(__PIC24HJ128GP504__)
    AD1PCFGL = 0xFFFF;
    RPOR9bits.RP18R = 11; // assign RP18 for SCK2
    RPOR8bits.RP16R = 10; // assign RP16 for SDO2
    RPINR22bits.SDI2R = 17; // assign RP17 for SDI2
#elif defined(__PIC24FJ256GB110__) || defined(__PIC24FJ256GA110__) || defined (__PIC24FJ256GB210__)
    __builtin_write_OSCCONL(OSCCON & 0xbf); // unlock PPS
    RPOR10bits.RP21R = 11; // assign RP21 for SCK2
    RPOR9bits.RP19R = 10; // assign RP19 for SDO2
    RPINR22bits.SDI2R = 26; // assign RP26 for SDI2
    __builtin_write_OSCCONL(OSCCON | 0x40); // lock   PPS
#endif

    // initialize the Flash Memory driver
    FlashInit(&SPI_Init_Data);

    // initialize the timer that manages the tick counter
    TickInit();

    // initialize the components for Resistive Touch Screen
    TouchInit(NVMWrite, NVMRead, NVMSectorErase, NULL);

   // HardwareButtonInit(); // Initialize the hardware buttons

#if !(defined(__dsPIC33FJ128GP804__) || defined(__PIC24HJ128GP504__)||defined(GFX_USE_DISPLAY_CONTROLLER_DMA))
    RTCCInit(); // Setup the RTCC
    RTCCProcessEvents();
#endif
        

// VGDD_MPLABX_WIZARD_END_SECTION *** DO NOT DELETE THIS LINE! ***
}

// Output text message on screen and stop execution

void ErrorTrap(XCHAR *message) {
    SetColor(BLACK);
    ClearDevice();
    SetFont((void *) &FONTDEFAULT);
    SetColor(WHITE);
    while (!OutTextXY(0, 0, message));
    while (1);
}

/////////////////////////////////////////////////////////////////////////////
// Function: Timer4 ISR
// PreCondition: none
// Input: none
// Output: none
// Side Effects: none
// Overview: increments tick counter. Tick is approx. 1 ms.
// Note: none
/////////////////////////////////////////////////////////////////////////////
#ifdef __PIC32MX__
#define __T4_ISR    __ISR(_TIMER_4_VECTOR, ipl1)
#else
#define __T4_ISR    __attribute__((interrupt, shadow, auto_psv))
#endif

#define TICK_PRESCALER	16
int tickscaler;

void __T4_ISR _T4Interrupt(void) {
    TMR4 = 0;
    if (tickscaler > TICK_PRESCALER) {
        tickscaler = 0;
        tick++;
    } else
        tickscaler++;

    TouchDetectPosition();

    // Clear flag
#ifdef __PIC32MX__
    mT4ClearIntFlag();
#else
    IFS1bits.T4IF = 0;
#endif
}

/////////////////////////////////////////////////////////////////////////////
// Function: void TickInit(void)
// Input: none
// Output: none
// Overview: Initilizes the tick timer.
/////////////////////////////////////////////////////////////////////////////

// Section: Tick Delay
#define SAMPLE_PERIOD       500 // us
#define TICK_PERIOD         (GetPeripheralClock() * SAMPLE_PERIOD) / 4000000

void TickInit(void) {
    // Initialize Timer4
#ifdef __PIC32MX__
    OpenTimer4(T4_ON | T4_PS_1_8, TICK_PERIOD);
    ConfigIntTimer4(T4_INT_ON | T4_INT_PRIOR_1);
#else
    TMR4 = 0;
    PR4 = TICK_PERIOD;
    IFS1bits.T4IF = 0; //Clear flag
    IEC1bits.T4IE = 1; //Enable interrupt
    T4CONbits.TON = 1; //Run timer
#endif
}

// C30 and C32 Exception Handlers
// If your code gets here, you either tried to read or write
// a NULL pointer, or your application overflowed the stack
// by having too many local variables or parameters declared.
#if defined(__C30__)
	void _ISR __attribute__((__no_auto_psv__)) _AddressError(void)
	{
	    Nop();
		Nop();
	}
	void _ISR __attribute__((__no_auto_psv__)) _StackError(void)
	{
	    Nop();
		Nop();
	}

#elif defined(__C32__)
		void _general_exception_handler(unsigned cause, unsigned status) {
    XCHAR *strException;
    static XCHAR strException0[]={'i','n','t','e','r','r','u','p','t',0};
    static XCHAR strException4[]={'a','d','d','r','e','s','s',' ','e','r','r','o','r',' ','(','l','o','a','d',' ','o','r',' ','i','f','e','t','c','h',')',0};
    static XCHAR strException5[]={'a','d','d','r','e','s','s',' ','e','r','r','o','r',' ','(','s','t','o','r','e',')',0};
    static XCHAR strException6[]={'b','u','s',' ','e','r','r','o','r',' ','(','i','f','e','t','c','h',')',0};
    static XCHAR strException7[]={'b','u','s',' ','e','r','r','o','r',' ','(','l','o','a','d','/','s','t','o','r','e',')',0};
    static XCHAR strException8[]={'s','y','s','c','a','l','l',0};
    static XCHAR strException9[]={'b','r','e','a','k','p','o','i','n','t',0};
    static XCHAR strException10[]={'r','e','s','e','r','v','e','d',' ','i','n','s','t','r','u','c','t','i','o','n',0};
    static XCHAR strException11[]={'c','o','p','r','o','c','e','s','s','o','r',' ','u','n','u','s','a','b','l','e',0};
    static XCHAR strException12[]={'a','r','i','t','h','m','e','t','i','c',' ','o','v','e','r','f','l','o','w',0};
    static XCHAR strException13[]={'t','r','a','p',' ','(','d','i','v','i','d','e',' ','b','y',' ','z','e','r','o','?',')',0};
    static XCHAR strExceptionX[]={'O','t','h','e','r',' ','e','x','c','e','p','t','i','o','n',0};
    switch ((cause & 0x0000007C) >> 2) {
        case 0:
            strException = strException0;
            break;
        case 4:
            strException = strException4;
            break;
        case 5:
            strException = strException5;
            break;
        case 6:
            strException = strException6;
            break;
        case 7:
            strException = strException7;
            break;
        case 8:
            strException = strException8;
            break;
        case 9:
            strException = strException9;
            break;
        case 10:
            strException = strException10;
            break;
        case 11:
            strException = strException11;
            break;
        case 12:
            strException = strException12;
            break;
        case 13:
            strException = strException13;
            break;
        default:
            strException = strExceptionX;
            break;
    }
    ErrorTrap(strException);
}
#endif
